const kPersonalAddressbookURI = "moz-abmdbdirectory://abook.mab";
const kCollectedAddressbookURI = "moz-abmdbdirectory://history.mab";

function doTest() {
  var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                    .getService(Components.interfaces.nsIPromptService);
  promptService.alert(null,'Test', 'doTest');
}

function update() {

//// < 0.8.3  : Preferences aus globalem ldap_2.servers.xxx in unseren Bereich verschieben
  count=new Object();
  prefs=new Object();
  this.mPrefBranch.getChildList ( "ldap_2.servers", count , prefs );
  if (!count.value) {
//this.promptService.alert(null,'update', 'must update: count='+count.value);

    // get all MAB Files
    var mabs=new Object();
    var cn = this.directory.childNodes;
    while( cn.hasMoreElements() )
    {
      var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
      var dirProp = this.TB3?dir:dir.directoryProperties;
      var dirType = dirProp.dirType;
      if (dirType==2) {            // ignore ldap-addressbooks (dirType!=2)
        var prefName = this.TB3?dirProp.dirPrefId:dirProp.prefName;
        if (mabs[prefName])
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName+'('+file+')\n');
//          this.promptService.alert(null,'update', 'nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName);
        else {
//          this.promptService.alert(null,'update', 'move '+dirProp.fileName);
          mabs[prefName]=dirProp;
          if (this.separateupdown) {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.up" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);

            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync.down" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          } else {
            try { sync = this.mGlobalPref.getBoolPref( prefName+".extensions.addressbookssync" ); }
              catch(e) { sync=false; }
            this.mPrefBranch.setBoolPref(prefName+'.up', sync);
            this.mPrefBranch.setBoolPref(prefName+'.down', sync);
          }
          try { sync = this.mGlobalPref.deleteBranch( prefName+".extensions.addressbookssync" ); }
            catch(e) { this.promptService.alert(null,'update', e); }
        }
      }
    } // while
    this.mGlobalPref.savePrefFile(null);  //save to prefs.js
  }
//else this.promptService.alert(null,'update', 'not updating');
//// Ende < 0.8.3

//// <= 0.8.4  : timedupload incorrectly stored as int
  try {
    var val=this.mPrefBranch.getIntPref("timedupload");
    // if this succeeds, we have to update
    this.mPrefBranch.deleteBranch("timedupload");
    this.mPrefBranch.setBoolPref("timedupload", val!=0);
    this.mGlobalPref.savePrefFile(null);  //save to prefs.js
  } catch(e) {  }
//// Ende <= 0.8.4

}

/*
 *  cleanup preferences
 */
function cleanup() {
  count=new Object();
  var prefs=this.mGlobalPref.getChildList("ldap_2.servers", count);
  var done=new Object();
  done['ldap_2.servers.default']=1;
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/(ldap_2.servers.[^.]+)\..+/,'$1');
    if (done[pref]) continue;
    done[pref]=1;
    try {
      this.mGlobalPref.getCharPref(pref+'.description');  //!!!!
    } catch(e) {
//this.promptService.alert(null, 'test', pref);
      try { sync = this.mGlobalPref.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  var prefs=this.mPrefBranch.getChildList("ldap_2.servers", count);
    //liefert _ALLE_keys
  for (var i=0; i<count.value; i++) {
    var pref=prefs[i];
    pref=pref.replace(/\.[^.]+$/,'');
    try {
      this.mGlobalPref.getCharPref(pref+'.description');
    } catch(e) {
      try { sync = this.mPrefBranch.deleteBranch(pref); }
        catch(e) { this.promptService.alert(null,'update', e); }
    }
  }

  this.mGlobalPref.savePrefFile(null);  //save to prefs.js

}

/*
 * returns list of mab to be synced
 */
function syncedAddressbooks(direction, singleBook)
{   //direction: up, down, all
  var mabs=new Object();
  var mabsArray=Components.classes["@mozilla.org/supports-array;1"]
         .createInstance(Components.interfaces.nsICollection);

  var cn = this.directory.childNodes;
  var found=false;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                  .getService(Components.interfaces.nsIPromptService);
    var dirProp = this.TB3?dir:dir.directoryProperties;
    if (dirProp.dirType==2) {            // ignore ldap-addressbooks (dirType!=2)
      var sync=false;
      if (direction=='all')
        sync=true
      else if (singleBook && dirProp.fileName==singleBook)
        sync=true;
      else if (!singleBook) {
        var prefName = this.TB3?dirProp.dirPrefId:dirProp.prefName;
        try { sync = this.mPrefBranch.getBoolPref(prefName+'.'+direction); }
          catch(e) { sync=false; }
      }
      if (sync) {
        found=true;
        var file = dirProp.fileName;
        if (mabs[file])
          dump('nsIAbDirectory::childNodes returned double addressbook '+dirProp.fileName+'('+file+')\n');
        else {
          mabs[file]=true;
          mabsArray.AppendElement(dir);
        }
      }
    }
  } // while
  if (!found && direction=='down' && singleBook) { //its a new addressbook
    var sb=Components.classes["@mozilla.org/supports-string;1"]
        .createInstance(Components.interfaces.nsISupportsString);
    sb.data=singleBook;
    mabsArray.AppendElement(sb);
  }
  return mabsArray;
}

/*
 * return address book data structure associated with filename or description (=address book name)
 * TODO: might fail, if called with a mabName and the mabName is in a foreign language!
 *        (see mails with Ivan Kolchagov, to reproduce: change personal address book to bulgarien name)
 */
function getAddressBook( name )
{
  var cn = this.directory.childNodes;
  while( cn.hasMoreElements() )
  {
    var dir = cn.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
    var dirProp = this.TB3?dir:dir.directoryProperties;
    var description=dir.dirName;
    if( dirProp.fileName == name || description == name) {
        return dir;
    }
  } // while
  return null;
} // getAddressBook

/*
 * create new address book
 */
function createAddressBook(name, fileName)
{
  if (this.TB3) {
    //TODO: gibts da 'ne Konstante oder Funktion?
    var uri='moz-abmdbdirectory://'+fileName;
    try {
//dump(name+' created from '+uri+'\n');
/*
ggf.
        var manager=Components.classes["@mozilla.org/abmanager;1"]
          .getService(Components.interfaces.nsIAbManager);
 ACString newAddressBook ( AString dirName , ACString URI , PRUint32 type )
*/
      this.directory.createDirectoryByURI( name, uri);

    } catch (e) {
      this.promptService.alert(null, 'ERROR TB3', 'createAddressBook('+name+','+fileName+')\n'+e);
      return null;
    }
  } else {
    var abProps = Components.classes["@mozilla.org/addressbook/properties;1"].
      createInstance(Components.interfaces.nsIAbDirectoryProperties);
    abProps.description = name;
    abProps.dirType = 2;
    abProps.fileName = fileName;
//    this.directory.createNewDirectory( abProps );
    var ab = Components.classes["@mozilla.org/addressbook;1"].
      getService(Components.interfaces.nsIAddressBook);
    ab.newAddressBook(abProps);
  }
  var dir=this.getAddressBook(fileName);
  dir.lastModifiedDate=this.mAppStarttime; //set to 'not modified'
  return dir;
} // createAddressBook

/*
 * delete an address book
 */
function deleteAddressBook( name, fileName )
{
  // Move focus away from the to be deleted addressbook
    // this has to be done in the AddressBook window :-((
//  try {  SetAbView(kPersonalAddressbookURI, false);} catch(e) { alert(e);}

  try {
    var dir=this.getAddressBook(fileName);
    var dirProp = this.TB3?dir:dir.directoryProperties;
    if (!dir || dirProp.URI==kPersonalAddressbookURI ||
            dirProp.URI==kCollectedAddressbookURI)
      return;

    var prefName = this.TB3?dirProp.dirPrefId:dirProp.prefName;
      //prefName='ldap_2.servers.name' mit name='history', 'pab' oder eigener
//      this.directory.deleteDirectory( dir );
    if (this.TB3) {
      var manager=Components.classes["@mozilla.org/abmanager;1"]
        .getService(Components.interfaces.nsIAbManager);
      manager.deleteAddressBook(dirProp.URI);
    } else {
      var ab = Components.classes["@mozilla.org/addressbook;1"].
                        getService(Components.interfaces.nsIAddressBook);
      var RDF = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                        getService(Components.interfaces.nsIRDFService);
      var parentArray = Components.classes["@mozilla.org/supports-array;1"].
                        createInstance(Components.interfaces.nsISupportsArray);
        var parentDir = RDF.GetResource("moz-abdirectory://").
                        QueryInterface(Components.interfaces.nsIAbDirectory);
        parentArray.AppendElement(parentDir);
      var resourceArray = Components.classes["@mozilla.org/supports-array;1"].
                        createInstance(Components.interfaces.nsISupportsArray);
        var selectedABResource = dir.
                        QueryInterface(Components.interfaces.nsIRDFResource);
        resourceArray.AppendElement(selectedABResource);
      var addressbookDS = RDF.GetDataSource("rdf:addressdirectory");
      ab.deleteAddressBooks(addressbookDS, parentArray, resourceArray);
    }
    this.mGlobalPref.clearUserPref( prefName+'.position' );  // sometimes remains!?
    this.mGlobalPref.deleteBranch( prefName );
    return true;
  } catch (e) {
this.promptService.alert(null, 'ERROR', 'deleteAddressBook('+name+','+fileName+')\n'+e);
    return false;
  }
} // deleteAddressBook

